﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows.Input;

namespace SampleGrid
{
    class ViewModel : INotifyPropertyChanged
    {
     
        private Car selectedCar;
        private ObservableCollection<Car> cars;
        
        public ViewModel()
        {
            CarsBusinessLogic cbl = new CarsBusinessLogic();
            cars = cbl.GetCars();
        
            selectedCar = null;
          
        }

             
        public ObservableCollection<Car> Cars
        {
            get { return cars; }
            set
            {
                if (cars != value)
                {
                    cars = value;
                    OnPropertyChanged("Cars");
                }
            }
        }

        private ICommand selCommand;
        public ICommand SelCommand
        {
            get
            {
                if (selCommand == null)
                {
                    selCommand = new RelayCommand<object>(SelCommandExecute, CanSelCommandExecute);
                }

                return selCommand;
            }
        }

        private void SelCommandExecute(object parameter)
        {
            SelectCar((Car) parameter);
        }

        private bool CanSelCommandExecute(object parameter)
        {
            // Code here
            return true;
        }

        private void SelectCar(Car car)
        {
            SelectedCar = car;
        }
        public Car SelectedCar
        {
            get { return selectedCar; }
            set
            {
                if (selectedCar != value)
                {
                    selectedCar = value;
                    OnPropertyChanged("SelectedCar");
                }
            }
        }


        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
        #endregion
    }
}
