﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Interactivity;
using Infragistics.Windows.DataPresenter;
using System.Windows.Input;
using System.Windows;
using System.ComponentModel;
using System.Collections.Specialized;
using System.Collections;

namespace SampleGrid
{
    class XamDataGridDoubleClickBehavior : Behavior<XamDataGrid>
    {
        private XamDataGrid Grid
        {
             get
            {
                return AssociatedObject as XamDataGrid;
            }
        }

        public ICommand ClickedCmd
        {
            get { return (ICommand)GetValue(ClickedCmdProperty); }
            set { SetValue(ClickedCmdProperty, value); }
        }

        public static readonly DependencyProperty ClickedCmdProperty = DependencyProperty.Register(
            "ClickedCmd",
            typeof(ICommand),
            typeof(XamDataGridDoubleClickBehavior),
            null);

        protected override void OnAttached()
        {
            base.OnAttached();
                        
            Grid.MouseDoubleClick += new MouseButtonEventHandler(Grid_MouseDoubleClick);

        }

        void Grid_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
          
            FrameworkElement fe = (FrameworkElement) e.OriginalSource;
           
            if (fe.DataContext is DataRecord)
            {
                DataRecord r = (DataRecord)fe.DataContext;

                ClickedCmd.Execute(r.DataItem);

            }
            
        }

       



    }
}
